/*******************************************************************************
 * Copyright (c) 2012 IBM Corporation and others.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompanies this distribution.
 *  
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 *
 *     Russell Boykin       - initial API and implementation
 *     Alberto Giammaria    - initial API and implementation
 *     Chris Peters         - initial API and implementation
 *     Gianluca Bernardini  - initial API and implementation
 *     Michael Fiedler      - Bugzilla adapter implementation
 *     Jad El-khoury        - initial implementation of code generator (https://bugs.eclipse.org/bugs/show_bug.cgi?id=422448)
 *     Matthieu Helleboid   - Allow Service Provider Factory class to be specific for each defined ServiceProvider
 *     Anass Radouani       - Allow Service Provider Factory class to be specific for each defined ServiceProvider
 *
 * This file is generated by org.eclipse.lyo.oslc4j.codegenerator
 *******************************************************************************/

package se.kth.md.adaptors.basicexample.servlet;

import java.net.URI;
import java.net.URISyntaxException;
import java.util.Map;

import org.eclipse.lyo.oslc4j.client.ServiceProviderRegistryURIs;
import org.eclipse.lyo.oslc4j.core.exception.OslcCoreApplicationException;
import org.eclipse.lyo.oslc4j.core.model.OslcConstants;
import org.eclipse.lyo.oslc4j.core.model.PrefixDefinition;
import org.eclipse.lyo.oslc4j.core.model.Publisher;
import org.eclipse.lyo.oslc4j.core.model.ServiceProvider;
import org.eclipse.lyo.oslc4j.core.model.ServiceProviderFactory;

import se.kth.md.adaptors.basicexample.BasicAdaptorConstants;
import se.kth.md.adaptors.basicexample.services.SoftwareProductAndDeveloperService;

// Start of user code imports
// End of user code

public class SoftwareProductAndDeveloperServiceProvidersFactory
{
    private static Class<?>[] RESOURCE_CLASSES =
    {
        SoftwareProductAndDeveloperService.class
    };

    private SoftwareProductAndDeveloperServiceProvidersFactory()
    {
        super();
    }

    public static ServiceProvider createServiceProvider(final String baseURI, final String title, final String description, final Publisher publisher, final Map<String,Object> parameterValueMap)
           throws OslcCoreApplicationException, URISyntaxException
    {
        final ServiceProvider serviceProvider = ServiceProviderFactory.createServiceProvider(baseURI,
                                                    ServiceProviderRegistryURIs.getUIURI(),
                                                    title,
                                                    description,
                                                    publisher,
                                                    RESOURCE_CLASSES,
                                                    parameterValueMap);
        URI detailsURIs[] = {new URI(baseURI)};
        serviceProvider.setDetails(detailsURIs);

        final PrefixDefinition[] prefixDefinitions =
        {
            new PrefixDefinition(OslcConstants.DCTERMS_NAMESPACE_PREFIX, new URI(OslcConstants.DCTERMS_NAMESPACE)),
            new PrefixDefinition(OslcConstants.OSLC_CORE_NAMESPACE_PREFIX, new URI(OslcConstants.OSLC_CORE_NAMESPACE)),
            new PrefixDefinition(OslcConstants.OSLC_DATA_NAMESPACE_PREFIX, new URI(OslcConstants.OSLC_DATA_NAMESPACE)),
            new PrefixDefinition(OslcConstants.RDF_NAMESPACE_PREFIX, new URI(OslcConstants.RDF_NAMESPACE)),
            new PrefixDefinition(OslcConstants.RDFS_NAMESPACE_PREFIX, new URI(OslcConstants.RDFS_NAMESPACE)),
            new PrefixDefinition(BasicAdaptorConstants.BASICDOMAIN_NAMSPACE_PREFIX, new URI(BasicAdaptorConstants.BASICDOMAIN_NAMSPACE))
,
            new PrefixDefinition(BasicAdaptorConstants.DUBLIN_CORE_NAMSPACE_PREFIX, new URI(BasicAdaptorConstants.DUBLIN_CORE_NAMSPACE))
,
            new PrefixDefinition(BasicAdaptorConstants.EXTENDED_REQUIRMENT_MANAGEMENT_NAMSPACE_PREFIX, new URI(BasicAdaptorConstants.EXTENDED_REQUIRMENT_MANAGEMENT_NAMSPACE))
,
            new PrefixDefinition(BasicAdaptorConstants.FOAF_NAMSPACE_PREFIX, new URI(BasicAdaptorConstants.FOAF_NAMSPACE))
,
            new PrefixDefinition(BasicAdaptorConstants.OSLC_NAMSPACE_PREFIX, new URI(BasicAdaptorConstants.OSLC_NAMSPACE))
,
            new PrefixDefinition(BasicAdaptorConstants.RDF_NAMSPACE_PREFIX, new URI(BasicAdaptorConstants.RDF_NAMSPACE))
,
            new PrefixDefinition(BasicAdaptorConstants.REQUIREMENTS_MANAGEMENT_NAMSPACE_PREFIX, new URI(BasicAdaptorConstants.REQUIREMENTS_MANAGEMENT_NAMSPACE))
        };

        serviceProvider.setPrefixDefinitions(prefixDefinitions);

        return serviceProvider;
    }
}
